#include <stdatomic.h>
#include <unrelacy.h>
#include <common.h>

#include <spec_lib.h>
#include <stdlib.h>
#include <cdsannotate.h>
#include <specannotation.h>
#include <model_memory.h>


template <typename t_element, size_t t_size>
struct mpmc_boundq_1_alt
{
private:
	
	unsigned int MASK;

		t_element               m_array[t_size];

		atomic<unsigned int>    m_rdwr;
		atomic<unsigned int>    m_read;
	atomic<unsigned int>    m_written;

public:

	mpmc_boundq_1_alt()
	{
	__sequential_init();
    	
		m_rdwr = 0;
		m_read = 0;
		m_written = 0;
		 		MASK = 0x1; 	}
	

/* All other user-defined structs */
/* All other user-defined functions */
/* Definition of interface info struct: Publish */
typedef struct Publish_info {
t_element * bin;
} Publish_info;
/* End of info struct definition: Publish */

/* ID function of interface: Publish */
inline static call_id_t Publish_id(void *info, thread_id_t __TID__) {
	Publish_info* theInfo = (Publish_info*)info;
	t_element * bin = theInfo->bin;

	call_id_t __ID__ = ( call_id_t ) bin;
	return __ID__;
}
/* End of ID function: Publish */

/* Check action function of interface: Publish */
inline static bool Publish_check_action(void *info, call_id_t __ID__, thread_id_t __TID__) {
	bool check_passed;
	Publish_info* theInfo = (Publish_info*)info;
	t_element * bin = theInfo->bin;

	return true;
}
/* End of check action function: Publish */

/* Definition of interface info struct: Fetch */
typedef struct Fetch_info {
t_element * __RET__;
} Fetch_info;
/* End of info struct definition: Fetch */

/* ID function of interface: Fetch */
inline static call_id_t Fetch_id(void *info, thread_id_t __TID__) {
	Fetch_info* theInfo = (Fetch_info*)info;
	t_element * __RET__ = theInfo->__RET__;

	call_id_t __ID__ = ( call_id_t ) __RET__;
	return __ID__;
}
/* End of ID function: Fetch */

/* Check action function of interface: Fetch */
inline static bool Fetch_check_action(void *info, call_id_t __ID__, thread_id_t __TID__) {
	bool check_passed;
	Fetch_info* theInfo = (Fetch_info*)info;
	t_element * __RET__ = theInfo->__RET__;

	return true;
}
/* End of check action function: Fetch */

/* Definition of interface info struct: Prepare */
typedef struct Prepare_info {
t_element * __RET__;
} Prepare_info;
/* End of info struct definition: Prepare */

/* ID function of interface: Prepare */
inline static call_id_t Prepare_id(void *info, thread_id_t __TID__) {
	Prepare_info* theInfo = (Prepare_info*)info;
	t_element * __RET__ = theInfo->__RET__;

	call_id_t __ID__ = ( call_id_t ) __RET__;
	return __ID__;
}
/* End of ID function: Prepare */

/* Check action function of interface: Prepare */
inline static bool Prepare_check_action(void *info, call_id_t __ID__, thread_id_t __TID__) {
	bool check_passed;
	Prepare_info* theInfo = (Prepare_info*)info;
	t_element * __RET__ = theInfo->__RET__;

	return true;
}
/* End of check action function: Prepare */

/* Definition of interface info struct: Consume */
typedef struct Consume_info {
t_element * bin;
} Consume_info;
/* End of info struct definition: Consume */

/* ID function of interface: Consume */
inline static call_id_t Consume_id(void *info, thread_id_t __TID__) {
	Consume_info* theInfo = (Consume_info*)info;
	t_element * bin = theInfo->bin;

	call_id_t __ID__ = ( call_id_t ) bin;
	return __ID__;
}
/* End of ID function: Consume */

/* Check action function of interface: Consume */
inline static bool Consume_check_action(void *info, call_id_t __ID__, thread_id_t __TID__) {
	bool check_passed;
	Consume_info* theInfo = (Consume_info*)info;
	t_element * bin = theInfo->bin;

	return true;
}
/* End of check action function: Consume */

#define INTERFACE_SIZE 4
static void** func_ptr_table;
static hb_rule** hb_rule_table;
static commutativity_rule** commutativity_rule_table;
inline static bool CommutativityCondition0(void *info1, void *info2) {
	Prepare_info *_info1 = (Prepare_info*) info1;
	Prepare_info *_info2 = (Prepare_info*) info2;
	return _info1-> __RET__ != _info2-> __RET__ || ! _info1-> __RET__ || ! _info2-> __RET__;
}
inline static bool CommutativityCondition1(void *info1, void *info2) {
	Prepare_info *_info1 = (Prepare_info*) info1;
	Publish_info *_info2 = (Publish_info*) info2;
	return _info1-> __RET__ != _info2-> bin || ! _info1-> __RET__;
}
inline static bool CommutativityCondition2(void *info1, void *info2) {
	Prepare_info *_info1 = (Prepare_info*) info1;
	Fetch_info *_info2 = (Fetch_info*) info2;
	return _info1-> __RET__ != _info2-> __RET__ || ! _info1-> __RET__ || ! _info2-> __RET__;
}
inline static bool CommutativityCondition3(void *info1, void *info2) {
	Prepare_info *_info1 = (Prepare_info*) info1;
	Consume_info *_info2 = (Consume_info*) info2;
	return _info1-> __RET__ != _info2-> bin || ! _info1-> __RET__;
}
inline static bool CommutativityCondition4(void *info1, void *info2) {
	Publish_info *_info1 = (Publish_info*) info1;
	Publish_info *_info2 = (Publish_info*) info2;
	return _info1-> bin != _info2-> bin;
}
inline static bool CommutativityCondition5(void *info1, void *info2) {
	Publish_info *_info1 = (Publish_info*) info1;
	Fetch_info *_info2 = (Fetch_info*) info2;
	return _info1-> bin != _info2-> __RET__ || ! _info2-> __RET__;
}
inline static bool CommutativityCondition6(void *info1, void *info2) {
	Publish_info *_info1 = (Publish_info*) info1;
	Consume_info *_info2 = (Consume_info*) info2;
	return _info1-> bin != _info2-> bin;
}
inline static bool CommutativityCondition7(void *info1, void *info2) {
	Fetch_info *_info1 = (Fetch_info*) info1;
	Fetch_info *_info2 = (Fetch_info*) info2;
	return _info1-> __RET__ != _info2-> __RET__ || ! _info1-> __RET__ || ! _info2-> __RET__;
}
inline static bool CommutativityCondition8(void *info1, void *info2) {
	Fetch_info *_info1 = (Fetch_info*) info1;
	Consume_info *_info2 = (Consume_info*) info2;
	return _info1-> __RET__ != _info2-> bin || ! _info1-> __RET__;
}
inline static bool CommutativityCondition9(void *info1, void *info2) {
	Consume_info *_info1 = (Consume_info*) info1;
	Consume_info *_info2 = (Consume_info*) info2;
	return _info1-> bin != _info2-> bin;
}

/* Initialization of sequential varialbes */
static void __SPEC_INIT__() {
}

/* Cleanup routine of sequential variables */
static bool __SPEC_CLEANUP__() {
	return true;
}

/* Define function for sequential code initialization */
inline static void __sequential_init() {
	/* Init func_ptr_table */
	func_ptr_table = (void**) malloc(sizeof(void*) * 4 * 2);
	func_ptr_table[2 * 3] = (void*) &Publish_id;
	func_ptr_table[2 * 3 + 1] = (void*) &Publish_check_action;
	func_ptr_table[2 * 0] = (void*) &Fetch_id;
	func_ptr_table[2 * 0 + 1] = (void*) &Fetch_check_action;
	func_ptr_table[2 * 2] = (void*) &Prepare_id;
	func_ptr_table[2 * 2 + 1] = (void*) &Prepare_check_action;
	func_ptr_table[2 * 1] = (void*) &Consume_id;
	func_ptr_table[2 * 1 + 1] = (void*) &Consume_check_action;
	/* Consume(true) -> Prepare(true) */
	struct hb_rule *hbConditionInit0 = (struct hb_rule*) malloc(sizeof(struct hb_rule));
	hbConditionInit0->interface_num_before = 1; // Consume
	hbConditionInit0->hb_condition_num_before = 0; // 
	hbConditionInit0->interface_num_after = 2; // Prepare
	hbConditionInit0->hb_condition_num_after = 0; // 
	/* Publish(true) -> Fetch(true) */
	struct hb_rule *hbConditionInit1 = (struct hb_rule*) malloc(sizeof(struct hb_rule));
	hbConditionInit1->interface_num_before = 3; // Publish
	hbConditionInit1->hb_condition_num_before = 0; // 
	hbConditionInit1->interface_num_after = 0; // Fetch
	hbConditionInit1->hb_condition_num_after = 0; // 
	/* Init hb_rule_table */
	hb_rule_table = (hb_rule**) malloc(sizeof(hb_rule*) * 2);
	#define HB_RULE_TABLE_SIZE 2
	hb_rule_table[0] = hbConditionInit0;
	hb_rule_table[1] = hbConditionInit1;
	/* Init commutativity_rule_table */
	commutativity_rule_table = (commutativity_rule**) malloc(sizeof(commutativity_rule*) * 10);
	commutativity_rule* rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 2;
	rule->interface_num_after = 2;
	rule->rule = "_Method1 . __RET__ != _Method2 . __RET__ || ! _Method1 . __RET__ || ! _Method2 . __RET__";
	rule->condition = CommutativityCondition0;
	commutativity_rule_table[0] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 2;
	rule->interface_num_after = 3;
	rule->rule = "_Method1 . __RET__ != _Method2 . bin || ! _Method1 . __RET__";
	rule->condition = CommutativityCondition1;
	commutativity_rule_table[1] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 2;
	rule->interface_num_after = 0;
	rule->rule = "_Method1 . __RET__ != _Method2 . __RET__ || ! _Method1 . __RET__ || ! _Method2 . __RET__";
	rule->condition = CommutativityCondition2;
	commutativity_rule_table[2] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 2;
	rule->interface_num_after = 1;
	rule->rule = "_Method1 . __RET__ != _Method2 . bin || ! _Method1 . __RET__";
	rule->condition = CommutativityCondition3;
	commutativity_rule_table[3] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 3;
	rule->interface_num_after = 3;
	rule->rule = "_Method1 . bin != _Method2 . bin";
	rule->condition = CommutativityCondition4;
	commutativity_rule_table[4] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 3;
	rule->interface_num_after = 0;
	rule->rule = "_Method1 . bin != _Method2 . __RET__ || ! _Method2 . __RET__";
	rule->condition = CommutativityCondition5;
	commutativity_rule_table[5] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 3;
	rule->interface_num_after = 1;
	rule->rule = "_Method1 . bin != _Method2 . bin";
	rule->condition = CommutativityCondition6;
	commutativity_rule_table[6] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 0;
	rule->interface_num_after = 0;
	rule->rule = "_Method1 . __RET__ != _Method2 . __RET__ || ! _Method1 . __RET__ || ! _Method2 . __RET__";
	rule->condition = CommutativityCondition7;
	commutativity_rule_table[7] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 0;
	rule->interface_num_after = 1;
	rule->rule = "_Method1 . __RET__ != _Method2 . bin || ! _Method1 . __RET__";
	rule->condition = CommutativityCondition8;
	commutativity_rule_table[8] = rule;
	rule = (commutativity_rule*) malloc (sizeof(commutativity_rule));
	rule->interface_num_before = 1;
	rule->interface_num_after = 1;
	rule->rule = "_Method1 . bin != _Method2 . bin";
	rule->condition = CommutativityCondition9;
	commutativity_rule_table[9] = rule;
	/* Pass init info, including function table info & HB rules & Commutativity Rules */
	struct anno_init *anno_init = (struct anno_init*) malloc(sizeof(struct anno_init));
	anno_init->init_func = (void_func_t) __SPEC_INIT__;
	anno_init->cleanup_func = (cleanup_func_t) __SPEC_CLEANUP__;
	anno_init->func_table = func_ptr_table;
	anno_init->func_table_size = INTERFACE_SIZE;
	anno_init->hb_rule_table = hb_rule_table;
	anno_init->hb_rule_table_size = HB_RULE_TABLE_SIZE;
	anno_init->commutativity_rule_table = commutativity_rule_table;
	anno_init->commutativity_rule_table_size = 10;
	struct spec_annotation *init = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	init->type = INIT;
	init->annotation = anno_init;
	cdsannotate(SPEC_ANALYSIS, init);

}

/* End of Global construct generation in class */
	

	

t_element * read_fetch() {
	/* Interface begins */
	struct anno_interface_begin *interface_begin = (struct anno_interface_begin*) malloc(sizeof(struct anno_interface_begin));
	interface_begin->interface_num = 0; // Fetch
		interface_begin->interface_name = "Fetch";
	struct spec_annotation *annotation_interface_begin = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_interface_begin->type = INTERFACE_BEGIN;
	annotation_interface_begin->annotation = interface_begin;
	cdsannotate(SPEC_ANALYSIS, annotation_interface_begin);
	t_element * __RET__ = __wrapper__read_fetch();
	struct anno_hb_condition *hb_condition = (struct anno_hb_condition*) malloc(sizeof(struct anno_hb_condition));
	hb_condition->interface_num = 0; // Fetch
	hb_condition->hb_condition_num = 0;
	struct spec_annotation *annotation_hb_condition = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_hb_condition->type = HB_CONDITION;
	annotation_hb_condition->annotation = hb_condition;
	cdsannotate(SPEC_ANALYSIS, annotation_hb_condition);

	Fetch_info* info = (Fetch_info*) malloc(sizeof(Fetch_info));
	info->__RET__ = __RET__;
	struct anno_interface_end *interface_end = (struct anno_interface_end*) malloc(sizeof(struct anno_interface_end));
	interface_end->interface_num = 0; // Fetch
	interface_end->info = info;
	struct spec_annotation *annoation_interface_end = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annoation_interface_end->type = INTERFACE_END;
	annoation_interface_end->annotation = interface_end;
	cdsannotate(SPEC_ANALYSIS, annoation_interface_end);
	return __RET__;
}
	
t_element * __wrapper__read_fetch() {
				unsigned int rdwr = m_rdwr.load(mo_acquire);
	/* Automatically generated code for potential commit point: Fetch_Potential_RW_Load */

	if (true) {
		struct anno_potential_cp_define *potential_cp_define = (struct anno_potential_cp_define*) malloc(sizeof(struct anno_potential_cp_define));
		potential_cp_define->label_num = 0;
		potential_cp_define->label_name = "Fetch_Potential_RW_Load";
		struct spec_annotation *annotation_potential_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_potential_cp_define->type = POTENTIAL_CP_DEFINE;
		annotation_potential_cp_define->annotation = potential_cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_potential_cp_define);
	}
				
		unsigned int rd,wr;
		for(;;) {
			rd = (rdwr>>16) & MASK;
			wr = rdwr & MASK;

			if ( wr == rd ) { 
	/* Automatically generated code for commit point define: Fetch_RW_Load_Empty */

	if (true) {
		struct anno_cp_define *cp_define = (struct anno_cp_define*) malloc(sizeof(struct anno_cp_define));
		cp_define->label_num = 1;
		cp_define->label_name = "Fetch_RW_Load_Empty";
		cp_define->potential_cp_label_num = 0;
		cp_define->potential_label_name = "Fetch_Potential_RW_Load";
		cp_define->interface_num = 0;
		struct spec_annotation *annotation_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define->type = CP_DEFINE;
		annotation_cp_define->annotation = cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define);
	}
				

				return false;
			}
			
			
			bool succ =
			m_rdwr.compare_exchange_weak(rdwr,rdwr+(1<<16),mo_acq_rel);
	/* Automatically generated code for commit point define check: Fetch_RW_RMW */

	if (succ) {
		struct anno_cp_define_check *cp_define_check = (struct anno_cp_define_check*) malloc(sizeof(struct anno_cp_define_check));
		cp_define_check->label_num = 2;
		cp_define_check->label_name = "Fetch_RW_RMW";
		cp_define_check->interface_num = 0;
		struct spec_annotation *annotation_cp_define_check = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define_check->type = CP_DEFINE_CHECK;
		annotation_cp_define_check->annotation = cp_define_check;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define_check);
	}
			
			if (succ)
				break;
			else
				thrd_yield();
		}

				rl::backoff bo;
		while (true) {
			
			int written = m_written.load(mo_acquire);
	/* Automatically generated code for potential commit point: Fetch_Potential_W_Load */

	if (true) {
		struct anno_potential_cp_define *potential_cp_define = (struct anno_potential_cp_define*) malloc(sizeof(struct anno_potential_cp_define));
		potential_cp_define->label_num = 3;
		potential_cp_define->label_name = "Fetch_Potential_W_Load";
		struct spec_annotation *annotation_potential_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_potential_cp_define->type = POTENTIAL_CP_DEFINE;
		annotation_potential_cp_define->annotation = potential_cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_potential_cp_define);
	}
			
			if ((written & MASK) != wr) {
				thrd_yield();
			} else {
				printf("Fetch: m_written=%d\n", written);
				break;
			}
		}
		
	/* Automatically generated code for commit point define: Fetch_W_Load */

	if (true) {
		struct anno_cp_define *cp_define = (struct anno_cp_define*) malloc(sizeof(struct anno_cp_define));
		cp_define->label_num = 4;
		cp_define->label_name = "Fetch_W_Load";
		cp_define->potential_cp_label_num = 3;
		cp_define->potential_label_name = "Fetch_Potential_W_Load";
		cp_define->interface_num = 0;
		struct spec_annotation *annotation_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define->type = CP_DEFINE;
		annotation_cp_define->annotation = cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define);
	}
		

		t_element * p = & ( m_array[ rd % t_size ] );
		
		return p;
	}


void read_consume(t_element * bin) {
	/* Interface begins */
	struct anno_interface_begin *interface_begin = (struct anno_interface_begin*) malloc(sizeof(struct anno_interface_begin));
	interface_begin->interface_num = 1; // Consume
		interface_begin->interface_name = "Consume";
	struct spec_annotation *annotation_interface_begin = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_interface_begin->type = INTERFACE_BEGIN;
	annotation_interface_begin->annotation = interface_begin;
	cdsannotate(SPEC_ANALYSIS, annotation_interface_begin);
	__wrapper__read_consume(bin);
	struct anno_hb_condition *hb_condition = (struct anno_hb_condition*) malloc(sizeof(struct anno_hb_condition));
	hb_condition->interface_num = 1; // Consume
	hb_condition->hb_condition_num = 0;
	struct spec_annotation *annotation_hb_condition = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_hb_condition->type = HB_CONDITION;
	annotation_hb_condition->annotation = hb_condition;
	cdsannotate(SPEC_ANALYSIS, annotation_hb_condition);

	Consume_info* info = (Consume_info*) malloc(sizeof(Consume_info));
	info->bin = bin;
	struct anno_interface_end *interface_end = (struct anno_interface_end*) malloc(sizeof(struct anno_interface_end));
	interface_end->interface_num = 1; // Consume
	interface_end->info = info;
	struct spec_annotation *annoation_interface_end = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annoation_interface_end->type = INTERFACE_END;
	annoation_interface_end->annotation = interface_end;
	cdsannotate(SPEC_ANALYSIS, annoation_interface_end);
}
	
void __wrapper__read_consume(t_element * bin) {
		
		m_read.fetch_add(1,mo_release);
	/* Automatically generated code for commit point define check: Consume_R_RMW */

	if (true) {
		struct anno_cp_define_check *cp_define_check = (struct anno_cp_define_check*) malloc(sizeof(struct anno_cp_define_check));
		cp_define_check->label_num = 5;
		cp_define_check->label_name = "Consume_R_RMW";
		cp_define_check->interface_num = 1;
		struct spec_annotation *annotation_cp_define_check = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define_check->type = CP_DEFINE_CHECK;
		annotation_cp_define_check->annotation = cp_define_check;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define_check);
	}
		
	}

	

t_element * write_prepare() {
	/* Interface begins */
	struct anno_interface_begin *interface_begin = (struct anno_interface_begin*) malloc(sizeof(struct anno_interface_begin));
	interface_begin->interface_num = 2; // Prepare
		interface_begin->interface_name = "Prepare";
	struct spec_annotation *annotation_interface_begin = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_interface_begin->type = INTERFACE_BEGIN;
	annotation_interface_begin->annotation = interface_begin;
	cdsannotate(SPEC_ANALYSIS, annotation_interface_begin);
	t_element * __RET__ = __wrapper__write_prepare();
	struct anno_hb_condition *hb_condition = (struct anno_hb_condition*) malloc(sizeof(struct anno_hb_condition));
	hb_condition->interface_num = 2; // Prepare
	hb_condition->hb_condition_num = 0;
	struct spec_annotation *annotation_hb_condition = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_hb_condition->type = HB_CONDITION;
	annotation_hb_condition->annotation = hb_condition;
	cdsannotate(SPEC_ANALYSIS, annotation_hb_condition);

	Prepare_info* info = (Prepare_info*) malloc(sizeof(Prepare_info));
	info->__RET__ = __RET__;
	struct anno_interface_end *interface_end = (struct anno_interface_end*) malloc(sizeof(struct anno_interface_end));
	interface_end->interface_num = 2; // Prepare
	interface_end->info = info;
	struct spec_annotation *annoation_interface_end = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annoation_interface_end->type = INTERFACE_END;
	annoation_interface_end->annotation = interface_end;
	cdsannotate(SPEC_ANALYSIS, annoation_interface_end);
	return __RET__;
}
	
t_element * __wrapper__write_prepare() {
						unsigned int rdwr = m_rdwr.load(mo_acquire);
	/* Automatically generated code for potential commit point: Prepare_Potential_RW_Load */

	if (true) {
		struct anno_potential_cp_define *potential_cp_define = (struct anno_potential_cp_define*) malloc(sizeof(struct anno_potential_cp_define));
		potential_cp_define->label_num = 6;
		potential_cp_define->label_name = "Prepare_Potential_RW_Load";
		struct spec_annotation *annotation_potential_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_potential_cp_define->type = POTENTIAL_CP_DEFINE;
		annotation_potential_cp_define->annotation = potential_cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_potential_cp_define);
	}
				
		unsigned int rd,wr;
		for(;;) {
			rd = (rdwr>>16) & MASK;
			wr = rdwr & MASK;
			
			if ( wr == ((rd + t_size)&MASK) ) { 
	/* Automatically generated code for commit point define: Prepare_RW_Load_Full */

	if (true) {
		struct anno_cp_define *cp_define = (struct anno_cp_define*) malloc(sizeof(struct anno_cp_define));
		cp_define->label_num = 7;
		cp_define->label_name = "Prepare_RW_Load_Full";
		cp_define->potential_cp_label_num = 6;
		cp_define->potential_label_name = "Prepare_Potential_RW_Load";
		cp_define->interface_num = 2;
		struct spec_annotation *annotation_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define->type = CP_DEFINE;
		annotation_cp_define->annotation = cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define);
	}
				
				return NULL;
			}
			
			
			bool succ = m_rdwr.compare_exchange_weak(rdwr,(rd<<16) |
				((wr+1)&MASK),mo_acq_rel);
	/* Automatically generated code for commit point define check: Prepare_RW_RMW */

	if (succ) {
		struct anno_cp_define_check *cp_define_check = (struct anno_cp_define_check*) malloc(sizeof(struct anno_cp_define_check));
		cp_define_check->label_num = 8;
		cp_define_check->label_name = "Prepare_RW_RMW";
		cp_define_check->interface_num = 2;
		struct spec_annotation *annotation_cp_define_check = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define_check->type = CP_DEFINE_CHECK;
		annotation_cp_define_check->annotation = cp_define_check;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define_check);
	}
			
						if (succ)
				break;
			else
				thrd_yield();
		}

				rl::backoff bo;
		while (true) {
			
			int read = m_read.load(mo_acquire);
	/* Automatically generated code for potential commit point: Prepare_Potential_R_Load */

	if (true) {
		struct anno_potential_cp_define *potential_cp_define = (struct anno_potential_cp_define*) malloc(sizeof(struct anno_potential_cp_define));
		potential_cp_define->label_num = 9;
		potential_cp_define->label_name = "Prepare_Potential_R_Load";
		struct spec_annotation *annotation_potential_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_potential_cp_define->type = POTENTIAL_CP_DEFINE;
		annotation_potential_cp_define->annotation = potential_cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_potential_cp_define);
	}
			
			if ((read & MASK) != rd)
				thrd_yield();
			else
				break;
		}

	/* Automatically generated code for commit point define: Prepare_R_Load */

	if (true) {
		struct anno_cp_define *cp_define = (struct anno_cp_define*) malloc(sizeof(struct anno_cp_define));
		cp_define->label_num = 10;
		cp_define->label_name = "Prepare_R_Load";
		cp_define->potential_cp_label_num = 9;
		cp_define->potential_label_name = "Prepare_Potential_R_Load";
		cp_define->interface_num = 2;
		struct spec_annotation *annotation_cp_define = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define->type = CP_DEFINE;
		annotation_cp_define->annotation = cp_define;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define);
	}
		

		t_element * p = & ( m_array[ wr % t_size ] );

		return p;
	}


void write_publish(t_element * bin) {
	/* Interface begins */
	struct anno_interface_begin *interface_begin = (struct anno_interface_begin*) malloc(sizeof(struct anno_interface_begin));
	interface_begin->interface_num = 3; // Publish
		interface_begin->interface_name = "Publish";
	struct spec_annotation *annotation_interface_begin = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_interface_begin->type = INTERFACE_BEGIN;
	annotation_interface_begin->annotation = interface_begin;
	cdsannotate(SPEC_ANALYSIS, annotation_interface_begin);
	__wrapper__write_publish(bin);
	struct anno_hb_condition *hb_condition = (struct anno_hb_condition*) malloc(sizeof(struct anno_hb_condition));
	hb_condition->interface_num = 3; // Publish
	hb_condition->hb_condition_num = 0;
	struct spec_annotation *annotation_hb_condition = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annotation_hb_condition->type = HB_CONDITION;
	annotation_hb_condition->annotation = hb_condition;
	cdsannotate(SPEC_ANALYSIS, annotation_hb_condition);

	Publish_info* info = (Publish_info*) malloc(sizeof(Publish_info));
	info->bin = bin;
	struct anno_interface_end *interface_end = (struct anno_interface_end*) malloc(sizeof(struct anno_interface_end));
	interface_end->interface_num = 3; // Publish
	interface_end->info = info;
	struct spec_annotation *annoation_interface_end = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
	annoation_interface_end->type = INTERFACE_END;
	annoation_interface_end->annotation = interface_end;
	cdsannotate(SPEC_ANALYSIS, annoation_interface_end);
}
	
void __wrapper__write_publish(t_element * bin)
	{
		
		int tmp = m_written.fetch_add(1,mo_release);
	/* Automatically generated code for commit point define check: Publish_W_RMW */

	if (true) {
		struct anno_cp_define_check *cp_define_check = (struct anno_cp_define_check*) malloc(sizeof(struct anno_cp_define_check));
		cp_define_check->label_num = 11;
		cp_define_check->label_name = "Publish_W_RMW";
		cp_define_check->interface_num = 3;
		struct spec_annotation *annotation_cp_define_check = (struct spec_annotation*) malloc(sizeof(struct spec_annotation));
		annotation_cp_define_check->type = CP_DEFINE_CHECK;
		annotation_cp_define_check->annotation = cp_define_check;
		cdsannotate(SPEC_ANALYSIS, annotation_cp_define_check);
	}
		
		printf("publish: m_written=%d\n", tmp + 1);
	}

	

};
template <typename t_element, size_t t_size>
void** mpmc_boundq_1_alt<t_element, t_size>::func_ptr_table;
template <typename t_element, size_t t_size>
hb_rule** mpmc_boundq_1_alt<t_element, t_size>::hb_rule_table;
template <typename t_element, size_t t_size>
commutativity_rule** mpmc_boundq_1_alt<t_element, t_size>::commutativity_rule_table;


